/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef WIN32
    #define stristr strcasestr
#endif



#define VER         "0.1"
#define BUFFSZ      16384



void qneftp_pwd(unsigned char *decpwd, unsigned char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE            *fd;
    unsigned char   buff[BUFFSZ + 1],
                    pwdbuff[BUFFSZ + 1],
                    *p,
                    *lim;


    setbuf(stdout, NULL);

    fputs("\n"
        "Quick 'n Easy FTP Server passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <USERS.XML>\n"
            "\n"
            "The file users.dat is located in the application's folder\n"
            "\n", argv[0]);
        fputs("\n   Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("- open file \"%s\"\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    while(fgets(buff, BUFFSZ, fd)) {
        p = stristr(buff, "<NAME>");
        if(p) {
            p += 6;
            lim = stristr(buff, "</NAME>");
            if(lim) *lim = 0;
            printf("\n  Username:   %s\n", p);
            continue;
        }

        p = stristr(buff, "<PASSWORD>");
        if(p) {
            p += 10;
            lim = stristr(buff, "</PASSWORD>");
            if(lim) *lim = 0;
            qneftp_pwd(pwdbuff, p);
            printf("  Password:   %s\n", pwdbuff);
            continue;
        }
    }

    fclose(fd);

    fputs("\n\n   Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void qneftp_pwd(unsigned char *decpwd, unsigned char *pwd) {
    unsigned char   *p1,
                    *p2,
                    *p3;
    int             i,
                    tmp,
                    len;

    p1 = p2 = pwd;  // very simple XML conversion
    while(*p1) {
        if(*p1 == '&') {
            p1 += 2;
            sscanf(p1, "%d;", &tmp);
            p1 = strchr(p1, ';') + 1;
            *p2 = tmp;
        } else {
            *p2 = *p1++;
        }
        p2++;
    }
    *p2 = 0;

    len = p2 - pwd;
    p2 = pwd;
    for(i = 0; i < len; i++) {
        *p2++ -= (i + len);
    }

    p1 = pwd;
    p2 = pwd + (len >> 1);
    p3 = decpwd;
    for(i = 0; i < len; i += 2) {
        *p3++ = *p2++;
        *p3++ = *p1++;
    }
    decpwd[len] = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}

